diff --git a/grammar/rainerscript.c b/grammar/rainerscript.c
index aeb62de2a5..1735730d3e 100644
--- a/grammar/rainerscript.c
+++ b/grammar/rainerscript.c
@@ -1677,6 +1677,38 @@ doFuncReplace(struct svar *__restrict__ const operandVal, struct svar *__restric
     return res;
 }
 
+
+static int ATTR_NONNULL()
+doFunc_json_parse(const char *__restrict__ const jsontext,
+	const char *__restrict__ const container,
+	smsg_t *const pMsg,
+	wti_t *pWti)
+{
+	int ret;
+	assert(jsontext != NULL);
+	assert(container != NULL);
+	assert(pMsg != NULL);
+
+	struct json_tokener *const tokener = json_tokener_new();
+	if(tokener == NULL) {
+		ret = 1;
+		goto finalize_it;
+	}
+	struct json_object *const json = json_tokener_parse_ex(tokener, jsontext, strlen(jsontext));
+	if(json == NULL) {
+		ret = RS_SCRIPT_EINVAL;
+	} else {
+		size_t off = (*container == '$') ? 1 : 0;
+		msgAddJSON(pMsg, (uchar*)container+off, json, 0, 0);
+		ret = RS_SCRIPT_EOK;
+	}
+	wtiSetScriptErrno(pWti, ret);
+	json_tokener_free(tokener);
+finalize_it:
+	return ret;
+}
+
+
 static es_str_t*
 doFuncWrap(struct svar *__restrict__ const sourceVal, struct svar *__restrict__ const wrapperVal,
 	struct svar *__restrict__ const escaperVal) {
@@ -1907,8 +1939,10 @@ doFuncCall(struct cnffunc *__restrict__ const func, struct svar *__restrict__ co
 {
 	char *envvar;
 	int bMustFree;
+	int bMustFree2;
 	es_str_t *estr;
 	char *str;
+	char *str2;
 	uchar *resStr;
 	int retval;
 	struct svar r[CNFFUNC_MAX_ARGS];
@@ -2246,6 +2280,16 @@ doFuncCall(struct cnffunc *__restrict__ const func, struct svar *__restrict__ co
 		ret->d.n = wtiGetPrevWasSuspended(pWti);
 		DBGPRINTF("previous_action_suspended() is %d\n", (int) ret->d.n);
 		break;
+	case CNFFUNC_JSON_PARSE:
+		cnfexprEval(func->expr[0], &r[0], usrptr, pWti);
+		cnfexprEval(func->expr[1], &r[1], usrptr, pWti);
+		str = (char*) var2CString(&r[0], &bMustFree);
+		str2 = (char*) var2CString(&r[1], &bMustFree2);
+		ret->datatype = 'N';
+		ret->d.n = doFunc_json_parse(str, str2, (smsg_t*) usrptr, pWti);
+		if(bMustFree) free(str);
+		if(bMustFree2) free(str2);
+		break;
 	default:
 		if(Debug) {
 			char *fname = es_str2cstr(func->fname, NULL);
@@ -4366,6 +4410,8 @@ funcName2ID(es_str_t *fname, unsigned short nParams)
 		GENERATE_FUNC("format_time", 2, CNFFUNC_FORMAT_TIME);
 	} else if(FUNC_NAME("parse_time")) {
 		GENERATE_FUNC("parse_time", 1, CNFFUNC_PARSE_TIME);
+	} else if(FUNC_NAME("json_parse")) {
+		GENERATE_FUNC("json_parse", 2, CNFFUNC_JSON_PARSE);
 	} else if(FUNC_NAME("script_error")) {
 		GENERATE_FUNC("script_error", 0, CNFFUNC_SCRIPT_ERROR);
 	} else if(FUNC_NAME("previous_action_suspended")) {
diff --git a/grammar/rainerscript.h b/grammar/rainerscript.h
index fb6915b54b..51cb05c8e5 100644
--- a/grammar/rainerscript.h
+++ b/grammar/rainerscript.h
@@ -239,8 +239,9 @@ enum cnffuncid {
 	CNFFUNC_RTRIM,
 	CNFFUNC_FORMAT_TIME,
 	CNFFUNC_PARSE_TIME,
-	CNFFUNC_SCRIPT_ERROR,
-	CNFFUNC_PREVIOUS_ACTION_SUSPENDED
+	CNFFUNC_JSON_PARSE,
+	CNFFUNC_PREVIOUS_ACTION_SUSPENDED,
+	CNFFUNC_SCRIPT_ERROR
 };
 
 struct cnffunc {
diff --git a/tests/Makefile.am b/tests/Makefile.am
index d22d8b4ad5..35391878fa 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -248,6 +248,7 @@ TESTS +=  \
 	rscript_format_time.sh \
 	rscript_parse_time.sh \
 	rscript_script_error.sh \
+	rscript_json_parse.sh \
 	rscript_previous_action_suspended.sh \
 	mmanon_random_32_ipv4.sh \
 	mmanon_random_cons_32_ipv4.sh \
@@ -922,6 +923,7 @@ EXTRA_DIST= \
 	rscript_parse_time.sh \
 	rscript_parse_time_get-ts.py \
 	rscript_script_error.sh \
+	rscript_json_parse.sh \
 	rscript_previous_action_suspended.sh \
 	mmanon_random_32_ipv4.sh \
 	mmanon_random_cons_32_ipv4.sh \
diff --git a/tests/rscript_json_parse.sh b/tests/rscript_json_parse.sh
new file mode 100755
index 0000000000..bb18ed8cee
--- /dev/null
+++ b/tests/rscript_json_parse.sh
@@ -0,0 +1,32 @@
+#!/bin/bash
+# Added 2017-12-09 by Rainer Gerhards, released under ASL 2.0
+. $srcdir/diag.sh init
+. $srcdir/diag.sh generate-conf
+. $srcdir/diag.sh add-conf '
+module(load="../plugins/imtcp/.libs/imtcp")
+input(type="imtcp" port="13514")
+template(name="outfmt" type="string" string="%$!%\n")
+
+local4.* {
+	set $.ret = json_parse("{ \"c1\":\"data\" }", "\$!parsed");
+	action(type="omfile" file="rsyslog.out.log" template="outfmt")
+}
+'
+
+. $srcdir/diag.sh startup
+. $srcdir/diag.sh tcpflood -m1
+. $srcdir/diag.sh shutdown-when-empty
+. $srcdir/diag.sh wait-shutdown
+
+# Our fixed and calculated expected results
+EXPECTED='{ "parsed": { "c1": "data" } }'
+echo $EXPECTED | cmp - rsyslog.out.log
+if [[ $? -ne 0 ]]; then
+  printf "Invalid function output detected!\n"
+  printf "expected:\n$EXPECTED\n"
+  printf "rsyslog.out is:\n"
+  cat rsyslog.out.log
+  . $srcdir/diag.sh error-exit 1
+fi;
+
+. $srcdir/diag.sh exit
